module approx_partial_product(
input logic signed [7:0] i_a,
input logic[2:0] radix_option,
output logic signed [8:0] partial_p
);

always @ * begin
	if (radix_option == 3'd3)
		partial_p = 2*i_a;
	else if (radix_option == 3'd4)
		partial_p = ~(2*i_a);
	else if ((radix_option == 3'd1) || (radix_option == 3'd2))
		partial_p = {i_a[7],i_a};
	else if ((radix_option == 3'd5) || (radix_option == 3'd6))
		partial_p = {~i_a[7],~(i_a)};
	else
		partial_p = 9'd0;
end



endmodule
