module approx_Si_find(
    input  logic signed [ 7:0] i_b,
    output reg [3:0] S,
    output reg [2:0] group[0:3]
);

reg [8:0] group_select_binary;

always @ *
  begin
    integer i;
    group_select_binary = {i_b, 1'b0};
    for (i = 0; i < 4; i = i+1)
      begin
        if (group_select_binary[2:0] == 3'b000 || group_select_binary[2:0] == 3'b111)
          S[i] = 1'b0;
        else
          S[i] = group_select_binary[2];
          
        group[i] = group_select_binary[2:0];
        group_select_binary = group_select_binary >> 2;
      end
  end

endmodule